<?php
namespace Service;

use Util\Events\Audit\Environment as Audit;
use Util\Events\Organization\Environment as Organization;
use Zeedhi\Framework\DependencyInjection\InstanceManager;
use Zeedhi\Framework\Session\Session;

class Environment implements Audit, Organization {

	/** @var \DateTime(); */
	protected $currentTime;
	/** @var Session */
	protected $session;

	public function __construct(Session $session) {
		$this->session = $session;
		$this->currentTime = new \DateTime();
	}

	public function getCurrentTime() {
		return $this->currentTime;
	}

	public function getCurrentUserId() {
		return $this->session->get('userId');
	}

	public function getCurrentOrganizationId() {
		return $this->session->get('organizationId');
	}

    /**
     * @return \Zeedhi\DevOps\Model\Projectmanagement\Entities\Organization
     */
	public function getCurrentOrganization() {
		$entityManager = InstanceManager::getInstance()->getService('entityManager');
		return $entityManager->find('\Zeedhi\DevOps\Model\Projectmanagement\Entities\Organization', $this->getCurrentOrganizationId());
	}

    /**
     * @return \Zeedhi\DevOps\Model\Projectmanagement\Entities\Resource
     */
	public function getCurrentUser() {
		$entityManager = InstanceManager::getInstance()->getService('entityManager');
		return $entityManager->find('\Zeedhi\DevOps\Model\Projectmanagement\Entities\Resource', $this->getCurrentUserId());
	}
} 