/******************************************************************************/
/* Sistemas Integrados TECNISA                                                */
/*                                                                            */
/* Compras e Suprimentos                                                      */
/*                                                                            */
/******************************************************************************/
/*                                                                            */
/* Nome:                                                                      */
/*   GERA_NF_AF_PARCIAL                                                       */
/* Descrio:                                                                 */
/* Rotina para gravar corpo de nota fiscal quando a baixa for parcial.        */
/*                                                                            */
/* Criao:                                                                   */
/*  20/10/2000 - Adriano de Arajo                                            */
/*                                                                            */
/******************************************************************************/
/* @C:\WIN_PRJ\SQL\ORACLE\8560_SUPSTP_GERA_NF_AF_PARCIAL.SQL                  */
/******************************************************************************/
/* EXECUTE GERA_NF_AF_PARCIAL('8888', '0000017126')                           */

CREATE OR REPLACE PROCEDURE GERA_NF_AF_PARCIAL
  (P_CDFILIAL    IN NOTAFISCAL.CDFILIAL%TYPE,
   P_NRLANCTONF  IN NOTAFISCAL.NRLANCTONF%TYPE)
IS
  V_CODIGO     VARCHAR2(20);
  V_ITEM_PARC  INT;
  V_TOTNF      NOTAFISCAL.VRNOTAFISC%TYPE;
  V_CDFILIRECE NOTAFISCAL.CDFILIRECE%TYPE;
BEGIN
   V_CODIGO := NULL;

   SELECT
      MAX(CDFILIRECE)
   INTO
      V_CDFILIRECE
   FROM
      NOTAFISCAL
   WHERE CDFILIAL   = P_CDFILIAL
     AND NRLANCTONF = P_NRLANCTONF;

   SELECT
      MAX(AUTOFORNE.VRTOTALAF) INTO V_TOTNF
   FROM
    ITEMAUTF,
    AUTOFORNE
   WHERE
    ITEMAUTF.CDFILLANC   = P_CDFILIAL   AND
    ITEMAUTF.NRLANCTONF  = P_NRLANCTONF AND
    ITEMAUTF.CDFILDEST   = V_CDFILIRECE AND
    NVL(ITEMAUTF.QTEFETENTRAF,0) < ITEMAUTF.QTPROGENTAF AND
    AUTOFORNE.CDFILDEST  = ITEMAUTF.CDFILDEST AND
    AUTOFORNE.CDFILLANC  = ITEMAUTF.CDFILLANC AND
    AUTOFORNE.NRAUTOFORN = ITEMAUTF.NRAUTOFORN;

   IF V_TOTNF IS NOT NULL THEN

     NOVO_CODIGO('LANCNF/FILIAL'||P_CDFILIAL, V_CODIGO);

     INSERT INTO NOTAFISCAL
     (CDFILIAL, NRLANCTONF, CDEMPRESA,
      CDINSCESTA, CDINSCMUNI, CDFORNECED, IDBLOQUEADO, VRPRODUTOS,
      VRNOTAFISC, IDENTRSAIDOP, IDSTATUS, CDTIPOOPER, DTENTRSAID,
      IDSISTEMA, CDFILIRECE)
     SELECT
      CDFILIAL, SUBSTR(V_CODIGO, 11, 10), CDEMPRESA,
      CDINSCESTA, CDINSCMUNI, CDFORNECED, 'N', VRPRODUTOS,
      (V_TOTNF - VRNOTAFISC), 'E', 'V', CDTIPOOPER, DTENTRSAID,
      'CMP', CDFILIRECE
     FROM
      NOTAFISCAL
     WHERE
      CDFILIAL   = P_CDFILIAL AND
      NRLANCTONF = P_NRLANCTONF;

     UPDATE ITEMAUTF
     SET NRLANCTONF = SUBSTR(V_CODIGO, 11, 10)
     WHERE ITEMAUTF.CDFILLANC  = P_CDFILIAL
      AND  ITEMAUTF.NRLANCTONF = P_NRLANCTONF
      AND  ITEMAUTF.CDFILDEST  = V_CDFILIRECE 
      AND  NVL(ITEMAUTF.QTEFETENTRAF,0) < ITEMAUTF.QTPROGENTAF;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('GERA_NF_AF_PARCIAL','4.11.176'); END;
/

