/* Sistemas Integrados TEKNISA
    
Nome: 9512_CVIVIEO_ETL_MOVBANCARIO.SQL

Descrio: view que retorna O MOVIMENTO BANCRIO POR DATA DA MOVIMENTAO (ANO/MES)

Criao:
04/07/2012 - Ftima Fernandes
*/

CREATE OR REPLACE FORCE VIEW "DM_MOVBANCARIO" ("CDEMPRESA", "CDREDUCONT", "DSCONTCORR", "DSFINALIDADE_CONTCORR",
 "CDANOBI", "CDMESBI", "VR_SALDO_INICIAL", "VR_TRANSFERENCIA_CREDITO", "VR_LANCAMENTO_CREDITO", "VR_CONTA_RECEBIDA",
 "VR_TRANSFERENCIA_DEBITO", "VR_LANCAMENTO_DEBITO", "VR_CONTA_PAGA", "VR_SALDO_FINAL")
AS
(SELECT CDEMPRESA, CDREDUCONT, DSCONTCORR, DSFINALIDADE_CONTCORR, 
           CDANOBI, CDMESBI, NVL(VR_SALDO_INICIAL, 0) VR_SALDO_INICIAL, 
           NVL(VR_TRANSFERENCIA_CREDITO, 0) VR_TRANSFERENCIA_CREDITO, 
           NVL(VR_LANCAMENTO_CREDITO, 0) VR_LANCAMENTO_CREDITO, 
           NVL(VR_CONTA_RECEBIDA, 0) VR_CONTA_RECEBIDA,
           NVL(VR_TRANSFERENCIA_DEBITO, 0) VR_TRANSFERENCIA_DEBITO, 
           NVL(VR_LANCAMENTO_DEBITO, 0) VR_LANCAMENTO_DEBITO, 
           NVL(VR_CONTA_PAGA, 0) VR_CONTA_PAGA,
           NVL(VR_SALDO_INICIAL, 0)+NVL(VR_TRANSFERENCIA_CREDITO, 0)+NVL(VR_LANCAMENTO_CREDITO, 0)+NVL(VR_CONTA_RECEBIDA, 0)
                                      -NVL(VR_TRANSFERENCIA_DEBITO, 0)-NVL(VR_LANCAMENTO_DEBITO, 0)-NVL(VR_CONTA_PAGA, 0) VR_SALDO_FINAL
      FROM (SELECT C.CDEMPRESA, 
                   DSCONTCORR,
                   CASE WHEN SUBSTR(C.DSCONTCORR, 1, 2) = 'AP' THEN 'Aplicao Financeira'
                        WHEN SUBSTR(C.DSCONTCORR, 1, 2) = 'CC' THEN 'Conta Corrente'
                        ELSE 'Idefinida'
                         END AS DSFINALIDADE_CONTCORR, -- DIMENSO 06001 FINALIDADE DA CONTA
                   M.CDREDUCONT, -- DIMENSO 06000 CONTA CORRENTE
                   M.CDANOBI,
                   M.CDMESBI, 
                   (SELECT VRSDOCCORR
                      FROM SDOCCORR
                     WHERE CDREDUCONT = M.CDREDUCONT
                       AND DTSDOCCORR = (SELECT MAX(DTSDOCCORR)
                                          FROM SDOCCORR
                                         WHERE CDREDUCONT = M.CDREDUCONT
                                           AND DTSDOCCORR <= DTSALDO)) VR_SALDO_INICIAL,
                   VR_TRANSFERENCIA_CREDITO, VR_LANCAMENTO_CREDITO, VR_CONTA_RECEBIDA,
                   VR_TRANSFERENCIA_DEBITO, VR_LANCAMENTO_DEBITO, VR_CONTA_PAGA
              FROM CONTCORR C, 
                   (SELECT MB.CDREDUCONT, 
                           TO_CHAR(MB.DTMOVBANC, 'YYYY') CDANOBI,
                           TO_CHAR(MB.DTMOVBANC, 'MM') CDMESBI,
                           TO_DATE(TO_CHAR(MB.DTMOVBANC, 'YYYY/MM')||'-01', 'YYYY/MM/DD')-1 DTSALDO,
                           SUM(CASE WHEN MB.IDORIGMBANC = 'T' AND MB.IDMOVBANC = 'C' THEN VRMOVBANC ELSE 0 END) VR_TRANSFERENCIA_CREDITO,
                           SUM(CASE WHEN MB.IDORIGMBANC = 'T' AND MB.IDMOVBANC = 'D' THEN VRMOVBANC ELSE 0 END) VR_TRANSFERENCIA_DEBITO,
                           SUM(CASE WHEN MB.IDORIGMBANC = 'C' THEN VRMOVBANC ELSE 0 END) VR_LANCAMENTO_CREDITO,
                           SUM(CASE WHEN MB.IDORIGMBANC = 'D' THEN VRMOVBANC ELSE 0 END) VR_LANCAMENTO_DEBITO, 
                           SUM(CASE WHEN MB.IDORIGMBANC = 'R' THEN VRMOVBANC ELSE 0 END) VR_CONTA_RECEBIDA,
                           SUM(CASE WHEN MB.IDORIGMBANC = 'P' THEN VRMOVBANC ELSE 0 END) VR_CONTA_PAGA
                      FROM MOVBANCARIO MB
                     GROUP BY MB.CDREDUCONT, TO_CHAR(MB.DTMOVBANC, 'YYYY'), TO_CHAR(MB.DTMOVBANC, 'MM'), TO_DATE(TO_CHAR(MB.DTMOVBANC, 'YYYY/MM')||'-01', 'YYYY/MM/DD')-1) M
             WHERE C.CDREDUCONT = M.CDREDUCONT))
/
BEGIN
--Fatos--
	CRIA_FATOS('DM_MOVBANCARIO', 'VR_SALDO_INICIAL'   		,'Saldo Inicial'		,'Saldo Inicial'			   ,'Mov. Bancrio');
	CRIA_FATOS('DM_MOVBANCARIO', 'VR_TRANSFERENCIA_CREDITO' 	,'Transf. Crdito'		,'Transferncia de Crdito'	   ,'Mov. Bancrio');
	CRIA_FATOS('DM_MOVBANCARIO', 'VR_LANCAMENTO_CREDITO' 		,'Lan. de Crdito'		,'Lanamento de Crdito'	   ,'Mov. Bancrio');
	CRIA_FATOS('DM_MOVBANCARIO', 'VR_CONTA_RECEBIDA'	 	,'Conta Recebida'		,'Conta Recebida'	   		   ,'Mov. Bancrio');
	CRIA_FATOS('DM_MOVBANCARIO', 'VR_TRANSFERENCIA_DEBITO'		,'Tranf. Dbito'		,'Tranferncia de Dbito'	   ,'Mov. Bancrio');
	CRIA_FATOS('DM_MOVBANCARIO', 'VR_LANCAMENTO_DEBITO'		,'Lan. de Dbito'		,'Lanamento de Dbito'	   	   ,'Mov. Bancrio');
	CRIA_FATOS('DM_MOVBANCARIO', 'VR_CONTA_PAGA'			,'Conta Paga'			,'Conta Paga'	   			   ,'Mov. Bancrio');
	CRIA_FATOS('DM_MOVBANCARIO', 'VR_SALDO_FINAL'			,'Saldo Final'			,'Saldo Final'	   			   ,'Mov. Bancrio');

--Dimenses--	
	CRIA_DIME('DM_MOVBANCARIO'	,'CDEMPRESA'				,'Empresa'			,'EMPRESA','CDEMPRESA','NMEMPRESA',NULL);
	CRIA_DIME('DM_MOVBANCARIO'	,'CDREDUCONT'				,'Conta Corrente'		,NULL	  ,NULL		  ,NULL		  ,NULL);
	CRIA_DIME('DM_MOVBANCARIO'	,'DSCONTCORR'				,'Desc. Conta Corrente'		,NULL	  ,NULL           ,NULL       	  ,NULL);
	CRIA_DIME('DM_MOVBANCARIO'	,'DSFINALIDADE_CONTCORR'		,'Finalidade'			,NULL	  ,NULL		  ,NULL		  ,NULL);
	CRIA_DIME('DM_MOVBANCARIO'	,'CDANOBI'				,'Ano'				,NULL	  ,NULL		  ,NULL		  ,NULL);
    CRIA_DIME('DM_MOVBANCARIO'	,'CDMESBI'					,'Ms'				,NULL	  ,NULL		  ,NULL		  ,NULL);
END;
/
-- VERSAO --
BEGIN ATUVEROBJ('DM_MOVBANCARIO','5.09.105'); END;
/
