/* Sistemas Integrados TEKNISA
  Integrao SPED FISCAL	

Nome: 0003_LSGFUNO_USR_COD_OBS.SQL

Descrio:
Funo para retornar a observao do documento fiscal.

PARA DEBUGAR
-- SET SERVEROUTPUT ON
-- DBMS_OUTPUT.PUT_LINE('xx');

Criao:
03/08/2009 - Cleison Ferreira
*/

create table USR_CODOBSFIS
(USR_CDOBSFIS   VARCHAR2(3),
 USR_DSOBSFIS   VARCHAR2(50))
/

create index USR_CODOBSFIS_01 on USR_CODOBSFIS (USR_DSOBSFIS asc)
/

/*  Trigger para criar o cdigo da mensagem  */
CREATE OR REPLACE TRIGGER USR_GRAVA_COD_OBS
BEFORE INSERT OR UPDATE ON IMPOSTONF FOR EACH ROW
DECLARE
   V_CODOBS  USR_CODOBSFIS.USR_CDOBSFIS%TYPE;
BEGIN
   IF NOT :NEW.DSOBSFISCIT IS NULL THEN
      V_CODOBS := NULL;
      SELECT MAX(USR_CDOBSFIS)
        INTO V_CODOBS
        FROM USR_CODOBSFIS
       WHERE UPPER(USR_DSOBSFIS) = UPPER(:NEW.DSOBSFISCIT);
      IF V_CODOBS IS NULL THEN
         SELECT LPAD(TO_NUMBER(NVL(MAX(USR_CDOBSFIS),'0')) + 1,3, '0')
           INTO V_CODOBS
           FROM USR_CODOBSFIS;

         INSERT INTO USR_CODOBSFIS (USR_CDOBSFIS, USR_DSOBSFIS)
         VALUES (V_CODOBS, :NEW.DSOBSFISCIT);
      END IF;
   END IF;
END;
/

/*  Funo para retornar o cdigo da mensagem  */
CREATE OR REPLACE FUNCTION USR_COD_OBS
 (P_DSOBSFISCIT  IN IMPOSTONF.DSOBSFISCIT%TYPE) RETURN VARCHAR
AS   V_CODOBS    VARCHAR2(3);
BEGIN
   V_CODOBS := NULL;

   SELECT MAX(USR_CDOBSFIS)
     INTO V_CODOBS
     FROM USR_CODOBSFIS
    WHERE UPPER(USR_DSOBSFIS) = UPPER(P_DSOBSFISCIT);

   RETURN (V_CODOBS);
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('USR_GRAVA_COD_OBS','5.42.000'); END;
/
