CREATE TABLE ARQXMLNFCESAT(
   CDFILIAL VARCHAR2(04) NOT NULL,
   CDCAIXA VARCHAR2(03) NOT NULL,
   NRSEQVENDA VARCHAR2(10) NOT NULL,
   DSARQXMLNFCE  CLOB,
   DSARQXMLCANCNFCE  CLOB,
   NRORG NUMBER DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg') NOT NULL,
   IDATIVO VARCHAR2(1) DEFAULT 'S' NOT NULL
		CONSTRAINT CKC_IDATIVO_ARQXMLNFCESAT CHECK (IDATIVO IN ('S', 'N')),
   DTINCLUSAO DATE NULL,
   DTULTATU DATE NULL,
   NRORGINCLUSAO NUMBER DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg') NULL,
   CDOPERINCLUSAO VARCHAR2(12) DEFAULT '1' NULL,
   NRORGULTATU NUMBER DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg')	NULL,
   CDOPERULTATU VARCHAR2(12) DEFAULT '1' NULL,
		CONSTRAINT PK_ARQXMLNFCESAT PRIMARY KEY (CDFILIAL, CDCAIXA, NRSEQVENDA)
)
/
CREATE INDEX VND00809_FK ON ARQXMLNFCESAT (CDFILIAL ASC, CDCAIXA ASC)
/

ALTER TABLE ARQXMLNFCESAT ADD CONSTRAINT FKVND00809ARQXMLNFCESAT_CAIXA FOREIGN KEY (CDFILIAL, CDCAIXA)
   REFERENCES CAIXA (CDFILIAL, CDCAIXA)
/

CREATE INDEX VND00810_FK ON ARQXMLNFCESAT (CDFILIAL ASC, CDCAIXA ASC, NRSEQVENDA ASC)
/

ALTER TABLE ARQXMLNFCESAT ADD CONSTRAINT FKVND00810ARQXMLNFCESAT_VENDA FOREIGN KEY (CDFILIAL, CDCAIXA, NRSEQVENDA)
   REFERENCES VENDA (CDFILIAL, CDCAIXA, NRSEQVENDA)
/